'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _materialUi = require('material-ui');

var _Search = require('material-ui-icons/Search');

var _Search2 = _interopRequireDefault(_Search);

var _Clear = require('material-ui-icons/Clear');

var _Clear2 = _interopRequireDefault(_Clear);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
    paperContainer: {
        display: 'flex',
        height: '50px',
        'justify-content': 'space-between'
    },
    inputContainer: {
        'align-self': 'center',
        'outline': 'none'
    },
    iconStyle: {
        width: '1em',
        height: '1em'
    }
};

var SearchBar = function (_Component) {
    _inherits(SearchBar, _Component);

    function SearchBar(props) {
        _classCallCheck(this, SearchBar);

        var _this = _possibleConstructorReturn(this, (SearchBar.__proto__ || Object.getPrototypeOf(SearchBar)).call(this, props));

        _this.createNotifier = function (debounceTime) {
            if (debounceTime <= 0) {
                _this.notify = function () {
                    return null;
                };
            } else {
                var debouncedFunction = (0, _lodash2.default)(function (value) {
                    _this.doNotify(value);
                }, debounceTime);

                _this.notify = function (value) {
                    debouncedFunction(value);
                };
            }
        };

        _this.doNotify = function () {
            var _this$props;

            (_this$props = _this.props).onChange.apply(_this$props, arguments);
        };

        _this.handleTextChangeEvent = function (event) {
            event.persist();
            var value = event.target.value;
            _this.setState(function (state) {
                return {
                    value: value, showClearButton: value && value.length
                };
            });

            if (value.length >= _this.props.minCharacterLength) {
                _this.notify(value);
            }
        };

        _this.handleTextClearEvent = function () {
            _this.setState({
                value: '',
                showClearButton: false
            });
        };

        _this.state = {
            showClearButton: props.showClearButton && props.value && props.value.length,
            value: props.value
        };
        return _this;
    }

    _createClass(SearchBar, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.createNotifier(this.props.debounceTime);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(_ref) {
            var value = _ref.value,
                debounceTime = _ref.debounceTime,
                showClearButton = _ref.showClearButton,
                isLoading = _ref.isLoading;

            this.setState(function (state) {
                return {
                    value: value,
                    showClearButton: showClearButton && value && value.length,
                    isLoading: isLoading
                };
            });
            this.createNotifier(debounceTime);
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _materialUi.Paper,
                { style: styles.paperContainer },
                _react2.default.createElement(
                    _materialUi.IconButton,
                    null,
                    this.props.isLoading && this.state.showClearButton ? _react2.default.createElement(_materialUi.CircularProgress, { style: styles.iconStyle, thickness: 4, size: 25 }) : _react2.default.createElement(_Search2.default, { style: styles.iconStyle })
                ),
                _react2.default.createElement(_materialUi.Input, { fullWidth: true, disableUnderline: true, style: styles.inputContainer,
                    onChange: this.handleTextChangeEvent, value: this.state.value,
                    placeholder: this.props.placeholder
                }),
                this.state.showClearButton && _react2.default.createElement(
                    _materialUi.IconButton,
                    { onClick: this.handleTextClearEvent },
                    _react2.default.createElement(_Clear2.default, { style: styles.iconStyle })
                )
            );
        }
    }]);

    return SearchBar;
}(_react.Component);

exports.default = SearchBar;


SearchBar.propTypes = {
    placeholder: _propTypes2.default.string,
    debounceTime: _propTypes2.default.number,
    onChange: _propTypes2.default.func.isRequired,
    minCharacterLength: _propTypes2.default.number,
    showClearButton: _propTypes2.default.bool,
    isLoading: _propTypes2.default.bool,
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired
};

SearchBar.defaultProps = {
    placeholder: 'Search..',
    debounceTime: 0,
    minCharacterLength: 3,
    showClearButton: true,
    isLoading: false
};